/*
 * EntityGrid Tyler 1998-2000.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   // import java.util.Random;
   import java.lang.Math;

   public class EntityGrid extends Object {
      static int nx = 10;
      static int ny = 8;
   
      static int log2binsize;
   
      static EntityList[][] entity_list;
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
   
      EntityGrid() {
         // entity_list = new int[nx][ny];
      }
   
   
      // l = log2 of the size of each bin in internal pixels...
      EntityGrid(int l) {
         log2binsize = l;
      
         nx = ((Shoals_Canvas.gsx << Entity.shift) >> log2binsize) + 1;
         ny = ((Shoals_Canvas.gsy << Entity.shift) >> log2binsize) + 1;
      
         debug("Resized... new grid - X: " + nx + " Y:" + ny);
      
         set_up_grid();
      }
   
   
   //final public static void resetGrid() {
   // }
   
   
      final public static void set_up_grid() {
         entity_list = new EntityList[nx][ny];
      
         for (temp = 0; temp < nx; temp++) {
            for (temp2 = 0; temp2 < ny; temp2++) {
               entity_list[temp][temp2] = new EntityList(); // blank to start with...
            }
         }
      }
   
   
      // bin = (x,y)
      final public static void addToList(int x, int y, Entity agent) {
         entity_list[x][y].add(agent);
      }
   
   
      final public static int removeFromList(int x, int y, Entity agent) {
      // sort this bug out!
      
         if (x >= nx)  {
            //debug("X:" + x + " NX:" + nx);
            return 0;
         }
         if (y >= ny) {
            //debug("Y:" + x + " NY:" + ny);
            return 0;
         }
         if (x < 0) {
            //debug("X:" + x + " NX:" + nx);
            return 0;
         }
         if (y < 0 ) {
            //debug("Y:" + x + " NY:" + ny);
            return 0;
         }
      
         entity_list[x][y].remove(agent);
         return 0;
      }
   
      final public static void dumpBins() {
         for (temp = 0; temp < nx; temp++) {
            for (temp2 = 0; temp2 < ny; temp2++) {
               System.out.print(" " + entity_list[temp][temp2].current_number);
            }
            System.out.println(" " );
         }
      }
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
