/*
 * Entity Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   // import java.util.Random;
   import java.lang.Math;

   public class Entity extends Object {
      static int shift = 8;
   
      int x; // Image offScrImage;
      int y; // 
   
      int dx; //
      int dy; // 
      int direction;
      int preferred_direction;
   
      int preserved_x;
      int preserved_y;
   
      int acceleration;
   
      int booked_for_speeding;
   
      int diameter = 18;
      int radius = diameter >>> 1;
   
      int detection_radius;
   
      int current_bin_x = -1;
      int current_bin_y = -1;
   
      Hortensius32Fast rnd = new Hortensius32Fast();
   
      boolean i_am_a_leader;
   
      static int max_velocity = 0x30 << 5;
   
      static int friction_strength = 4;
   
      static int temp_detection_distance;
      static int temp_detection_distance_squared;
   
      static Hortensius32Fast static_rnd = new Hortensius32Fast();
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static int agent_counter;
      static int temp_direction;
      static int temp_count;
   
      static int tadx;
      static int tady;
      static int t2adx;
      static int t2ady;
   
      static int temp_x, temp_y;
      static int temp_radius, temp_diameter;
   
      static Entity temp_agent;
      static Entity temp2_agent;
      // static Shoals_Leader temp_leader;
   
      static int number_of_agents     = 32;
      static int number_of_leaders    = 1;
   
      static int acc_of_leader = 0xC0;
   
      static int[] sin_tab;
      static int[] cos_tab;
   
      static int lut_shift = 8;
      static int lut_magnitude = 1 << lut_shift;
   
      static int TRIG_TAB_SIZE = 4;
      static int TRIG_TAB_SIZEMO = TRIG_TAB_SIZE - 1;
      static int TRIG_TAB_SIZEO2 = TRIG_TAB_SIZE >>> 1;
   
      // static int drawn_ship_size = diameter;
      static int number_of_ship;
   
      static int xoffset = 0;
      static int yoffset = 0;
   
      static int number_of_ships = TRIG_TAB_SIZE;
   
      static Ships ship;
   
      static Image ship_image_array[];
      static Image ring_image;
      static Graphics temp_graphics_handle;
   
      static int direction_bias = 0;
   
      Entity() {
      }
   
   
      Entity(int ix, int iy, int seed) {
         x = ix;// << shift;
         y = iy;// << shift;
      
         rnd.setSeed(seed);
         dx = 0;
         dy = 0;
      
         direction = 0;
         i_am_a_leader = false;
      
         acceleration = 4;
      
         setSize(EntityManager.general_size);
      }
   
   
      final public static void initial() {
         sin_tab = new int[TRIG_TAB_SIZE];
         cos_tab = new int[TRIG_TAB_SIZE];
         for (temp = 0; temp < TRIG_TAB_SIZE; temp++) {
            sin_tab[temp] = (int)(lut_magnitude * (java.lang.Math.sin((temp * 2 * java.lang.Math.PI) / (double)TRIG_TAB_SIZE)) + 0.5);
            cos_tab[temp] = (int)(lut_magnitude * (java.lang.Math.cos((temp * 2 * java.lang.Math.PI) / (double)TRIG_TAB_SIZE)) + 0.5);
         }
      
         ship_image_array = new Image[number_of_ships];
      
         // agent = new Entity[number_of_agents];setSi
      
      
         //for (temp = 0; temp < number_of_agents; temp++) {
            //agent[temp] = new Entity(static_rnd.nextInt(Shoals_Canvas.gsx),static_rnd.nextInt(Shoals_Canvas.gsy), static_rnd.nextInt());
         //}
      
         //leader = new Shoals_Leader[number_of_leaders];
      
         //for (temp = 0; temp < number_of_leaders; temp++) {
            //leader[temp] = new Shoals_Leader(static_rnd.nextInt(Shoals_Canvas.gsx),static_rnd.nextInt(Shoals_Canvas.gsy), static_rnd.nextInt());
         //}
      }
   
   
      public void makeShips(int ship_size, int n) {
         ship        = new Ships();
         ship.aa_col = 0x002020;
         ship.pixel  = 0.5;
         ship.shadow = 0.5;
         ship.ship_type = 3;
         ship.rnd.setSeed(1);
         ship.generateShip(diameter, direction);
      
         ship_image_array[number_of_ship] = ship.ship_white;
      }
   
   
      protected void drawShip() {
         temp_radius = diameter; // drawn_ship_size;
      
         number_of_ship = direction;
      
         // System.out.println("11");
      
         if (ship_image_array[number_of_ship] == null)
            makeShips(diameter,number_of_ship);
      
         // System.out.println("12");
      
         if (Shoals_Canvas.observer != null) {
            if (Shoals_Grid.graphics_handle != null) {
               Shoals_Grid.graphics_handle.drawImage(ship_image_array[number_of_ship], temp_x, temp_y, temp_radius, temp_radius, Shoals_Canvas.observer);
            }
         }
      }
   
   
      public void draw() {
         preserved_x = ((x) >>> shift);
         preserved_y = ((y) >>> shift);
      
         temp_x = preserved_x - radius;
         temp_y = preserved_y - radius;
         temp = radius + 2;
      
         switch (Shoals.quality) {
            case Shoals._QUALITY_0:
               drawShip();
            
               break;
         
            case Shoals._QUALITY_1:
               Shoals_Grid.graphics_handle.fillOval(temp_x, temp_y, diameter, diameter);
               // Shoals_Grid.graphics_handle.drawLine(preserved_x, preserved_y, preserved_x + ((sin_tab[direction] * diameter) >> lut_shift), preserved_y + ((cos_tab[direction] * diameter) >> lut_shift));
               //Shoals_Grid.graphics_handle.drawRect(preserved_x - 1 - ((cos_tab[direction] * temp) >> lut_shift), preserved_y - 1 - ((sin_tab[direction] * temp) >> lut_shift), 2, 2);
            
               break;
         
            case Shoals._QUALITY_2:
               Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
               //Shoals_Grid.graphics_handle.drawRect(preserved_x - 1 - ((cos_tab[direction] * temp) >> lut_shift), preserved_y - 1 - ((sin_tab[direction] * temp) >> lut_shift), 2, 2);
            
               break;
         
            case Shoals._QUALITY_3:
               //Shoals_Grid.graphics_handle.fillRect(preserved_x, temp_y, 1, diameter);
               //Shoals_Grid.graphics_handle.fillRect(temp_x, preserved_y, diameter, 1);
               Shoals_Grid.graphics_handle.drawRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
            
               break;
         
         }
      
         // Shoals_Grid.graphics_handle.drawLine(preserved_x, preserved_y, preserved_x + ((sin_tab[direction] * diameter) >> lut_shift), preserved_y + ((cos_tab[direction] * diameter) >> lut_shift));
      }
   
   
      public void scrub() {
         //preserved_x = ((x * Shoals_Grid.gridsize) >>> shift);
         //preserved_y = ((y * Shoals_Grid.gridsize) >>> shift);
      
         // Shoals_Grid.graphics_handle.fillRect(preserved_x - radius,preserved_y - radius,diameter,diameter);
      
         temp_x = preserved_x - radius;
         temp_y = preserved_y - radius;
         temp = radius + 2;
      
         switch (Shoals.quality) {
            case Shoals._QUALITY_0:
               Shoals_Grid.graphics_handle.fillRect(temp_x, temp_y, diameter, diameter);
            
               break;
         
            case Shoals._QUALITY_1:
               Shoals_Grid.graphics_handle.fillRect(temp_x, temp_y, diameter + 1, diameter + 1);
               // Shoals_Grid.graphics_handle.drawLine(preserved_x, preserved_y, preserved_x + ((sin_tab[direction] * diameter) >> lut_shift), preserved_y + ((cos_tab[direction] * diameter) >> lut_shift));
               //Shoals_Grid.graphics_handle.drawRect(preserved_x - 1 - ((cos_tab[direction] * temp) >> lut_shift), preserved_y - 1 - ((sin_tab[direction] * temp) >> lut_shift), 2, 2);
            
               break;
         
            case Shoals._QUALITY_2:
               Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
               //Shoals_Grid.graphics_handle.drawRect(preserved_x - 1 - ((cos_tab[direction] * temp) >> lut_shift), preserved_y - 1 - ((sin_tab[direction] * temp) >> lut_shift), 2, 2);
            
               break;
         
            case Shoals._QUALITY_3:
               //Shoals_Grid.graphics_handle.fillRect(preserved_x, temp_y, 1, diameter);
               //Shoals_Grid.graphics_handle.fillRect(temp_x, preserved_y, diameter, 1);
               Shoals_Grid.graphics_handle.drawRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
            
               break;
         }
      
         // Shoals_Grid.graphics_handle.fillOval(preserved_x - radius,preserved_y - radius,diameter,diameter);
      
         // Shoals_Grid.graphics_handle.drawLine(preserved_x, preserved_y, preserved_x + ((sin_tab[direction] * diameter) >> lut_shift), preserved_y + ((cos_tab[direction] * diameter) >> lut_shift));
      }
   
   
      public void plot() {
         // if (Shoals_Grid.out_grid[x >>> shift][y >>> shift] >= 0) { //  Shoals_Grid.WALL) {
            // Shoals_Grid.out_grid[x >>> shift][y >>> shift] = excretes;
         // }
      }
   
   
      /*public static void setGlobalSize(int d) {
         general_size = d;
         for (temp = 0; temp < number_of_agents; temp++) {
            agent[temp].setSize(d);
         }
      
         for (temp = 0; temp < TRIG_TAB_SIZE; temp++) {
            ship_image_array[temp] = null;
         }
      
         ring_image = null;
      }*/
   
   
      public void setSize(int d) {
         diameter = d; 
         radius = diameter >>> 1;
         detection_radius = (radius + 1) << shift;
      }
   
   
      public void travel() {
         temp = static_rnd.nextInt();
      
         if ((temp & 0x8000000) == 0) {
            dx = dx + acceleration;
         }
         else
         {
            dx = dx - acceleration;
         }
      
         if ((temp & 0x800000) == 0) {
            dy = dy + acceleration;
         }
         else
         {
            dy = dy - acceleration;
         }
      
         capVelocities();
      
         x = x + dx;
         y = y + dy;
      
         applyFriction();
      
         boundaryCheck();
      
         adjustDirection();
      }
   
   
      public void thrust(int t) {
         temp_direction = (direction - preferred_direction) & TRIG_TAB_SIZEMO;
         if ((temp_direction < 8) || (temp_direction > (TRIG_TAB_SIZEMO - 7))) {
         // thrusting
            dx += (cos_tab[direction] * t) >> (8 + lut_shift);
            dy += (sin_tab[direction] * t) >> (8 + lut_shift);
         
            if (booked_for_speeding < 2) {
               if ((booked_for_speeding == 0) || ((Shoals_Grid.generation & 3) == 0)) {
                  if (Shoals.show_exhaust) {
                     temp_y = x ^ y ^ Shoals_Grid.generation;
                     temp_radius = 0x60000 + ((temp_y & 15) << 16);
                     temp_x = 128 - ((temp_y & 15) << 4);
                     temp_y = 128 - ((temp_y & 15) << 4);
                  
                     Shoals_Grid.particle_manager.add(x, y,
                                          dx - ((cos_tab[direction] * temp_radius) >> (8 + lut_shift)) + temp_x, // - 256 + (x & 511),
                                          dy - ((sin_tab[direction] * temp_radius) >> (8 + lut_shift)) + temp_y); //  - 256 + (y & 511));
                  }
               }
            }
         }
      }
   
   
      public void adjustDirection() {
         // direction = preferred_direction; // (direction + ((dx + dy) >> (shift + 2))) & TRIG_TAB_SIZEMO;
      
         temp = (direction - preferred_direction) & TRIG_TAB_SIZEMO;
         if (temp > TRIG_TAB_SIZEO2) {
            direction = (direction + 1) & TRIG_TAB_SIZEMO;
         }
         else
         {
            direction = (direction - 1) & TRIG_TAB_SIZEMO;
         }
      }
   
   
      public void capVelocities() {
         booked_for_speeding = 0;
      
         // cap velocities...
         if ((dx > max_velocity) || (dx < -max_velocity) || (dy > max_velocity) || (dy < -max_velocity)) {
            if (max_velocity == 0) {
               dx = 0;
               dy = 0;
            }
            else
            {
               if (dx > (max_velocity << 2))
                  dx = max_velocity << 2;
               if (dx < -(max_velocity << 2))
                  dx = -(max_velocity << 2);
               if (dy > (max_velocity << 2))
                  dy = max_velocity << 2;
               if (dy < -(max_velocity << 2))
                  dy = -(max_velocity << 2);
            
               //temp = 3;
               while (((dx * dx) + (dy * dy)) > (((max_velocity) * (max_velocity)) << 1)) {
               //while ((((dx * dx) + (dy * dy)) > (((max_velocity) * (max_velocity)) << 1)) && (temp-- > 0)) {
                  dx = dx >> 1;
                  dy = dy >> 1;
                  booked_for_speeding++;
               }
            }
         }
      /*
         if (dx < -max_velocity) {
            dx = -max_velocity;
            booked_for_speeding++;
         }
      
         if (dy > max_velocity) {
            dy = max_velocity;
            booked_for_speeding++;
         }
      
         if (dy < -max_velocity) {
            dy = -max_velocity;
            booked_for_speeding++;
         }
      	*/
      }
   
   
      public void boundaryCheck() {
         if (((x + detection_radius) >> shift) > Shoals_Canvas.gsx) {
            x = (Shoals_Canvas.gsx << shift) - detection_radius; //x - dx;
            if (dx > 0)
               dx = -(int)(dx * 0.95);
         }
      
         if (x < detection_radius) {
            x = detection_radius;
            if (dx < 0)
               dx = -(int)(dx * 0.95);
         }
      
         temp = (Shoals_Canvas.gsy * (EntityManager.piston + 50)) / 1050;
         if (((y + detection_radius) >> shift) > temp) {
            y = (temp << shift) - detection_radius; //x - dx;
            if (dy > 0)
               dy = -(int)(dy * 0.95);
         }
      
         if (y < detection_radius) {
            y = detection_radius;
            if (dy < 0)
               dy = -(int)(dy * 0.95);
         }
      }
   
   
      public void applyFriction() {
      // cap velocities...
         if ((Shoals_Grid.generation & 7) == 0) {
            if (dx > 0) {
               dx -= friction_strength;
               if (dx < 0) 
                  dx = 0;
            }
         
            if (dx < 0) {
               dx += friction_strength;
               if (dx > 0) 
                  dx = 0;
            }
         
            if (dy > 0) {
               dy -= friction_strength;
               if (dy < 0) 
                  dy = 0;
            }
         
            if (dy < 0) {
               dy += friction_strength;
               if (dy > 0) 
                  dy = 0;
            }
         }
      }
   
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
