/*
 * Particle Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Math;

   public class Particle extends Object {
      static int shift = 8;
   
      int x; // Image offScrImage;
      int y; // 
   
      int dx; //
      int dy; // 
   
      // int excretes;
      int count;
   
      static int friction_strength = 4;
   
      int temp_x;
      int temp_y;
   
      static int temp;
   
      static int diameter = 18;
      static int radius = diameter >>> 1;
   
      Particle() {
      }
   
      Particle(int ix, int iy, int idx, int idy) {
         x = ix - idx;
         y = iy - idy;
      
         dx = idx;
         dy = idy;
      }
   
   
      // in internal co-ordinates....
      final public void set(int ix, int iy, int idx, int idy) {
         x = ix - idx;
         y = iy - idy;
      
         dx = idx;
         dy = idy;
      
         count = 8 + (dx + dy) & 15;
      }
   
   
      final public static void initial() {
      }
   
   
      public void draw() {
         // Shoals_Grid.graphics_handle.setColor(Shoals_Grid.agent_colour);
         Shoals_Grid.graphics_handle.drawRect(x >>> shift, y >>> shift, 1, 1);
      }
   
   
      public void scrub() {
         // Shoals_Grid.graphics_handle.setColor(Shoals_Grid.bg_colour);
         Shoals_Grid.graphics_handle.drawRect(x >>> shift, y >>> shift,1 ,1);
      }
   
   
      public void travel() {
         x = x + dx;
         y = y + dy;
      
         applyFriction();
      
         count--;
      
      	//if (count < 0) {
      
      	// }
      /*
         if ((x >> shift) > Shoals_Canvas.gsx) {
            x = Shoals_Canvas.gsx << shift; //x - dx;
            dx = -(int)(dx * 0.9);
         }
      
         if (x < 0) {
            x = 0;
            dx = -(int)(dx * 0.9);
         }
      
         if ((y >> shift) > Shoals_Canvas.gsy) {
            y = Shoals_Canvas.gsy << shift; //x - dx;
            dy = -(int)(dy * 0.9);
         }
      
         if (y < 0) {
            y = 0;
            dy = -(int)(dy * 0.9);
         }
      */
         // absdx = (dx > 0) ? dx : -dx;
         // absdy = (dy > 0) ? dy : -dy;
      
        //  adjustDirection();
      }
   
   
      public void applyFriction() {
      
      // cap velocities...
         if ((Shoals_Grid.generation & 7) == 0) {
            if (dx > 0) {
               dx -= friction_strength;
            }
         
            if (dx < 0) {
               dx += friction_strength;
            }
         
            if (dy > 0) {
               dy -= friction_strength;
            }
         
            if (dy < 0) {
               dy += friction_strength;
            }
         }
      }
   
   }
