/*
 * Shoals_Traveller Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.util.Random;

   public class Shoals_Traveller extends Object {// implements MouseListener, MouseMotionListener {
      int x; // Image offScrImage;
      int y; // 
   
      int dx; //
      int dy; // 
   
      static int temp;
      Random rnd = new Random();
   
      final static int shift = 4;
      final static int MAX_VELOCITY = 0xF << shift;
   
      Shoals_Traveller(int ix, int iy, int seed) {
         x = ix << shift;
         y = iy << shift;
      
         rnd.setSeed(seed);
         dx = 0;
         dy = 0;
      }
   
   
      final public void plot() {
         //if (Shoals_Grid.out_grid[x >>> shift][y >>> shift] >= 0) { //  Shoals_Grid.WALL) {
           // Shoals_Grid.out_grid[x >>> shift][y >>> shift] = 255;
         //}
      }
   
   
      final public void travel() {
         temp = rnd.nextInt();
      
         if ((temp & 0x8000000) == 0) {
            if (dx < MAX_VELOCITY) {
               dx++;
            }
         }
         else
         {
            if (dx > -MAX_VELOCITY) {
               dx--;
            }
         }
      
      
         if ((temp & 0x800000) == 0) {
            if (dy < MAX_VELOCITY) {
               dy++;
            }
         }
         else
         {
            if (dy > -MAX_VELOCITY) {
               dy--;
            }
         }
      
         x = x + dx;
         y = y + dy;
      
         if ((x >>> shift) > Shoals_Grid.hsidemo) {
            x = x - dx;
            dx = -(dx / 2);
         }
      
         if (x < 0) {
            x = x - dx;
            dx = -(dx / 2);
         }
      
         if ((y >>> shift) > Shoals_Grid.vsidemo) {
            y = y - dy;
            dy = -(dy / 2);
         }
      
         if (y < 0) {
            y = y - dy;
            dy = -(dy / 2);
         }
      }
   
   }
